Playground biometrics demo Playground BioID home page Company Website

JSON Web API FaceImageQuality

Performs face image quality measurements by calling into the Open Source Face Image Quality (OFIQ) library. With this library we currently perform these 28 quality measures.
Please note that this library is subject of the OFIQ License

Request

POST /api/ofiq/v1/faceimagequality

Request Body

Content type: application/json

{
  "image": "string"
}

The FaceImageQuality request object has a single field:

imags
The binary input image data, base64 encoded.

The maximum API request size is 50 MB.

Request Headers

This API requires a valid JWT in the Authorization request header and accepts an optional reference number.

Authorization Required Bearer authentication. Please refer to BWS API Authentication for a description of how to provide a valid JWT here.
Reference-Number Optional, client specific reference number, which will be added to the BWS bookkeeping as well as to the response header. You typically use this reference to link the resulting BWS bookkeeping entries with your logs.

Response

Response Body

Content type: application/json

{
  "status": "SUCCEEDED",
  "errors": [
    {
      "errorCode": "string",
      "message": "string"
    }
  ],
  "qualityMeasurements": [
    {
      "measure": "Unspecified",
      "rawValue": 0,
      "scalarScore": 0
    }
  ]
}

On success the API returns a FaceImageQuality response object with the fields as follows:

status
The status of the BWS job that processed the request. The following fields are typically only set, when the job has succeeded.
errors
A list of errors that might have occurred while the request has been processed.
qualityMeasurements
The list of performed quality measurements. Each of the measurements contains the fields:
measure
The quality measure performed. This is a string containing the name of one of the well known quality assessment algorithm identifiers listed in the QualityMeasure enum as found in the protobuf.
rawValue
The raw score as computed by the quality measure implementation.
scalarScore
A scalar value from the interval [0, 100] computed from the raw score. Higher values mean better quality. A score of 100 indicates optimal quality, while 0 indicates a severe defect.

BWS Errors

In case none or not all of the quality measurements have benn calculated, this API might report one of the following OFIQ return codes in the errors field:

FaceDetectionError
Unable to detect a face in the image.
FaceLandmarkExtractionError
Unable to extract landmarks from face.
FaceOcclusionSegmentationError
Unable to extract occlusion segments from face.
FaceParsingError
Unable to parse face.
UnknownError
An unknown or unspecified error occurred.
QualityAssessmentError
Failure to generate a quality score on the input image.

HTTP Status Codes

The call returns one of the standard HTTP status codes, e.g.:

200 (OK)
The response body contains the FaceImageQuality response object as described above.
400 (Bad Request)
The call failed, typically due to an invalid argument. The response body contains a JSON object with the reported gRPC error code and message.
401 (Unauthorized)
The request does not have valid authentication credentials for the operation.
408 (Request Timeout)
Client application cancelled the request.
500 (Internal Server Error)
Server experienced some unexpected behaviour.
503 (Service Unavailable)
The service is currently unavailable. This is a most likely a transient condition and may be corrected by retrying with a backoff.

Response Headers

All successful BWS calls return a response header containing additional information about the request:

jobid The Job-ID (a GUID) that has been assigned to this BWS call.
bws-version The version of the BWS gRPC service.
reference-number An optional reference number as provided in the request header.
date The timestamp when the request has been received at the server.
... Other headers that might have been added by the server (NGINX, Kestrel, ...) that was handling the request.